--* Begin List of Functions & Procedures *
---> File: C:\EUPHORIA\AAADAN\LISTRTNS\LISTRTNS.EX
--function StripRtnList(object o)
--function ListEuRoutines(sequence fname)
--function ProcessEuFiles(sequence path_name,sequence entry)
--* End List of Functions & Procedures   *
--**************************************
--ListRtns program in Euphoria v2.1
--by DB James (Quark) - 8/1/99 - 10/09/99
--Purpose: Find and list routines to the top of Euphoria files and/or
--place the routines lists in a file called C:\EUPHORIA\ROUTINES.
--Can also delete these routines from Euphoria files.
--The user can see at a glance all the routines in the file(s).
--**************************************
include get.e
include qtext.e
include qfs.e
include file.e
include wildcard.e
--======================================
--Definitions
integer key,state,go,mode,key2
sequence routines,m1,m2,m3,rc,f,path
--======================================
--with trace
--======================================
--Procedures & Functions
----------------------------------------
function StripRtnList(object o)
--Read a file and strip previously written routines listing from file
integer copy,changed
sequence t,h1,h2
h1="--* Begin List of Functions & Procedures *"
h2="--* End List of Functions & Procedures   *"
t={}
copy=TRUE
changed = FALSE
   if atom(o) then
      return {changed,o}
   else
      for i=1to length(o) do
	 if sequence(o[i]) then
	    if equal(Strip(o[i],DELIMETERS,2),h1) then --stop copying lines
	       copy=FALSE
	       changed=TRUE
	    end if
	    if copy=TRUE then
	       t=append(t,o[i])
	    end if
	    if equal(Strip(o[i],DELIMETERS,2),h2) then --start copying lines
	       copy=TRUE
	    end if
	 end if
      end for
   if changed then
      return {changed,t}
   else
      return {changed,o}
   end if
   end if
end function
----------------------------------------
function ListEuRoutines(sequence fname)
--Find and list to the top of a Euphoria file
--all procedures and functions unless this has previously been done.
--The user can see at a glance all the routines of a file.

sequence data,list,s1,s2,s3,t,t2
integer cancel,x,found,stripIsChanged,doRecord

s1="--* Begin List of Functions & Procedures *\n"
s2="---> File: "&fname&'\n'
s3="--* End List of Functions & Procedures   *\n"
list={}
t={}
list=append(list,s1)
list=append(list,s2)
data=GetFile(fname)
cancel=NOPROBLEM

stripIsChanged=FALSE

if data[1]=PROBLEM or equal(length(data[2]),0) then
    return PROBLEM --error
else
    data=StripRtnList(data[2])
    stripIsChanged=data[1]
    data=data[2]
end if

if atom(data) then
    return PROBLEM
else
  found=FALSE
  if not equal(key,'4') then
     doRecord=FALSE
     for i = 1 to length(data) do
	 t=Tokenize(StripComment(data[i]),DELIMETERS)
	 if doRecord then
	    --do nothing
	 elsif length(t) then
	    if equal(t[1],"procedure") then
	       doRecord=TRUE
	    end if
	    if equal(t[1],"function") then
	       doRecord=TRUE
	    end if
	    if length(t)>1 and (equal(t[1],"global") and equal(t[2],"procedure")) then
	       doRecord=TRUE
	    end if
	    if length(t)>1 and (equal(t[1],"global") and equal(t[2],"function")) then
	       doRecord=TRUE
	    end if
	 end if

	 if doRecord then
	    found=TRUE
	    doRecord=FALSE
	    list=append(list,'-'&'-'&data[i]) --add to list
	    if equal(length(t),0) then
	       doRecord=TRUE --allow blank lines in declaration
	    else
	       t2=t[length(t)]
	       if not equal(')',t2[length(t2)]) then
		  doRecord=TRUE --routine not declared on one line
	       end if
	    end if
	 end if

      end for
  end if

  if found then
     list=append(list,s3)
     if equal(key,'1') or equal(key,'3') then
	for i =1 to length(list) do
	    routines=append(routines,list[i])
	end for
	routines[length(routines)]&='\n'
     end if
     if equal(key,'2') or equal(key,'3') then
	--Write list and data to fname file
	for i =1 to length(data) do
	    list=append(list,data[i])
	end for
	x=WriteFile(fname,list)
	Pause("Writing file: "&fname,10)
     end if
  elsif equal(key,'4') and stripIsChanged then
     x=WriteFile(fname,data)
     Pause("Writing file: "&fname,10)
  end if

end if
return NOPROBLEM -- no error
end function
----------------------------------------
function ProcessEuFiles(sequence path_name,sequence entry)
    integer status
    if state=2 then
       Msg("Processing: "&path_name&entry)
       status=ListEuRoutines(path_name&entry)
    else
       if wildcard_file("*.e",entry[D_NAME]) or
	   wildcard_file("*.ex",entry[D_NAME]) or
	   wildcard_file("*.ew",entry[D_NAME]) or
	   wildcard_file("*.ewx",entry[D_NAME]) then
	   Msg("Processing: "&path_name&"\\"&entry[D_NAME])
	   status=ListEuRoutines(path_name&'\\'&entry[D_NAME])
       end if
    end if
    return NOPROBLEM
end function
----------------------------------------
--======================================
--Main
m1={
"LISTRTNS looks at Euphoria files and extracts declarations of functions and ",
"procedures and places these in a sequence to create a routines list.  The   ",
"routines lists can be written to a single file in the Euphoria directory    ",
"with the name ROUTINES.  LISTRTNS can also write a list to the top of the   ",
"Euphoria file from which the list came.  I find such a list to be useful and",
"I hope you agree.                                                           ",
" ",
"Rob Craig looked at an earlier version of this program and asked for a     ",
"safeguard against a casual use of the program which blithely changed EVERY ",
"Euphoria file under the Euphoria directory.  Hence, these options:...      ",
" ",
"========================================================================== ",
" ",
"1) Select one or more files from a directory of your choice --SAFER!       ",
" ",
"2) Action applies to ALL files in a Euphoria directory--WARNING!           ",
"     Note: you can still choose to ONLY write the ROUTINES file--SAFE!     ",
" ",
"3) Exit the program.                                                       "
}
m2={
" ",
"You have chosen to select one or more files.  Here are your action options ",
"for these files:                                                           ",
" ",
"========================================================================== ",
" ",
"1) Place the routines-list for the selected files in the ROUTINES file.    ",
" ",
"2) Place each file's routines-list at the TOP of the selected file.        ",
"     Note: this will delete old listings automatically.                    ",
" ",
"3) Do BOTH 1) and 2).                                                      ",
" ",
"4) Delete old routines lists from the selected files.                      ",
" ",
"5) Exit                                                                    ",
" ",
" ",
" "
}
m3={
" ",
"You have chosen to act on ALL files in a Euphoria directory.               ",
"Here are your action options:                                              ",
" ",
"========================================================================== ",
" ",
"1) Place the routines-list for these Euphoria files in the ROUTINES file.  ",
" ",
"2) Place each file's routines-list at the TOP of that file.                ",
"     Note: this will delete old listings automatically.                    ",
" ",
"3) Do BOTH 1) and 2).                                                      ",
" ",
"4) Delete old routines lists from all Euphoria files.                      ",
" ",
"5) Exit                                                                    ",
" ",
" ",
" "
}

bk_color(GREEN)
text_color(BLACK)
state=1
while state do
   routines={}
   clear_screen()
   rc={1,1,MAXROW-2,MAXCOL}
   QBox(rc,"Quark's LISTRTNS.EX -- a Euphoria program to list Euphoria routines")
   Pause("This is the message line...",125)
   Pause("Some information and options...",125)

   for i=1to length(m1) do
      CenterAt(i+3,m1[i])
   end for

   key = Response(" Enter your choice <1-3>: ","1,2,3")

   if equal(key,'1') then
      state=2
      for i=1to length(m2) do
	 CenterAt(i+3,m2[i])
      end for
      key = Response(" Enter your choice <1-5>: ","1,2,3,4,5")
   elsif equal(key,'2') then
      state=3
      for i=1to length(m3) do
	 CenterAt(i+3,m3[i])
      end for
      key = Response(" Enter your choice <1-5>: ","1,2,3,4,5")
   elsif equal(key,'3') then
     state=0
   end if

   if equal(state,0) or equal(key,'5') then
      key=Lower(Response("Continue? <Y/N>","YNyn"))
      if equal(key,'n') then
	 state=0
      else
	 state=1
      end if
   else
      if equal(state,2) then --Select files
	 f=fs() --major routine allowing file selection
	 clear_screen()
	 rc={1,1,MAXROW-2,MAXCOL}
	 QBox(rc,"Quark's LISTRTNS.EX -- a Euphoria program to list Euphoria routines")
	 --trace(1)
	 if equal(f[1],"HasFiles") then
	    for i=1 to length(f[3]) do
	       go=ProcessEuFiles(f[2],f[3][i])
	    end for
	 end if
	 state=1
      elsif equal(state,3) then --No file select, use walk_dir
	 path="C:\\EUPHORIA"
	 --path="c:\\euphoria"
	 Pause("User input coming up...",150)
	 Pause("Default path = "&path,175)
	 key2=Lower(Response("Enter new path? <Y/N>","YNyn"))
	 if equal(key2,'y') then
	    Pause("Enter the next item carefully...",175)
	    Msg("Enter new path, using single \\s, like this: "&"c:\\euphoria")
	    position(MAXROW-1,2)
	    path=Input(76)
	    BlankLine(MAXROW-1)
	    BlankLine(MAXROW)
	 end if
	 mode=0
	 Pause("User input coming up...",150)
	 Pause("Either restrict action to a directory or allow sub-directories.",175)
	 key2=Lower(Response("Allow sub-directories? <Y/N>","YNyn"))
	 if equal(key2,'y') then
	    mode=1
	 end if
	 go=walk_dir(path,routine_id("ProcessEuFiles"),mode)
	 state=1
      end if
      if equal(key,'1') or  equal(key,'3') then
	 go=WriteFile("C:\\EUPHORIA\\ROUTINES",routines)
	 Pause("Check C:\\EUPHORIA\\ROUTINES for your routines listing.",175)
      elsif equal(key,'2') then
	 Pause(" A routines list has been added to the file(s).",175)
      elsif equal(key,'4') then
	 Pause(" The routines list has been stripped from the files.",175)
      end if
      Pause(" Done.  Thanks for using LISTRTNS.",175)
   end if

end while
Pause("Bye for now...",175)
if graphics_mode(-1) then
end if
--End Main
--======================================



